"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var cookie_universal_1 = __importDefault(require("cookie-universal"));
var api_1 = require("@src/api");
function useCookie(cookieName, enableParseJSON, runOnMount) {
    if (enableParseJSON === void 0) { enableParseJSON = false; }
    if (runOnMount === void 0) { runOnMount = true; }
    var cookieLib = cookie_universal_1.default(undefined, undefined, enableParseJSON);
    var cookie = api_1.ref(null);
    var getCookie = function () {
        var cookieVal = cookieLib.get(cookieName);
        if (typeof cookieVal !== 'undefined')
            cookie.value = cookieVal;
    };
    var setCookie = function (
    // The user may pass a 'string', a 'number', or a valid JSON object/array
    // so it is better to set allowed cookie value as 'any'
    newVal, options) {
        cookieLib.set(cookieName, newVal, options);
        cookie.value = newVal;
    };
    var removeCookie = function (options) {
        cookieLib.remove(cookieName, options);
        cookie.value = null;
    };
    api_1.onMounted(function () { return runOnMount && getCookie(); });
    return { cookie: cookie, getCookie: getCookie, setCookie: setCookie, removeCookie: removeCookie };
}
exports.useCookie = useCookie;
